﻿
using System.ComponentModel;
using Styx;
using Styx.Common;
using Styx.Helpers;
using Styx.WoWInternals.WoWObjects;

// ReSharper disable once CheckNamespace

namespace IssueMailer.Settings
{
    internal class IMSettings : Styx.Helpers.Settings
    {
        private static IMSettings _instance;

        private static LocalPlayer Me
        {
            get { return StyxWoW.Me; }
        }

        private IMSettings()
            : base(SettingsPath + ".config")
        {
        }

        public static IMSettings Instance
        {
            get { return _instance ?? (_instance = new IMSettings()); }
        }

        private static new string SettingsPath
        {
            get
            {
                return string.Format("{0}\\IMSettings\\Settings_{1}_2", Utilities.AssemblyDirectory, Me.Name);
            }
        }


        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("- Mail Settings")]
        [DisplayName("Enable Mail Sending")]
        [Description("Allow IssueMailer to send out mails")]
        public bool EnableMailing { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("- Plugin")]
        [DisplayName("Enable Quest Checker")]
        [Description("Check if Quests beeing processed within timeframe configured.")]
        public bool EnableQuestCheck { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("- Plugin")]
        [DisplayName("Enable Stop Notifier")]
        [Description("Receive a mail when the bot stops.")]
        public bool EnableStopNotifier { get; set; }


        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("- Plugin")]
        [DisplayName("Enable Stuck Checker")]
        [Description("Check if Bot is moving within timeframe configured.")]
        public bool EnableStuckCheck { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("- Plugin")]
        [DisplayName("Enable Whisper Mailer")]
        [Description("You get a mail if somebody whispers you.")]
        public bool EnableWhispers { get; set; }
        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("- Plugin")]
        [DisplayName("Enable Death Mailer")]
        [Description("You get a mail if you die XX times wihin XX minutes.")]
        public bool EnableDeathMail { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(15)]
        [Category("- Time Settings")]
        [DisplayName("QUEST | Send Mail after XX (minutes)")]
        [Description("Duration in minutes to wait before a mail will be send after NO QUEST was proceed.")]
        public int MailTimeQuest { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(3)]
        [Category("- Time Settings")]
        [DisplayName("DEATH | How many times you die within timeframe")]
        [Description("Duration in minutes you have to die within the timeframe to get a mail.")]
        public int MailDeathCount { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(8)]
        [Category("- Time Settings")]
        [DisplayName("DEATH | Timeframe for death count")]
        [Description("Duration in minutes the timeframe count deaths.")]
        public int MailDeathTime { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(3)]
        [Category("- Time Settings")]
        [DisplayName("STUCK | Send Mail after XX (minutes)")]
        [Description("Duration in minutes to wait before a mail will be send after Bot has NOT moved.")]
        public int MailTimeStuck { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue("yourmail@gmail.com")]
        [Category("- Mail Settings")]
        [DisplayName("Email Sender (GMAIL)")]
        [Description("This MUST! be an GMAIL account which you are sending FROM. Other Mail Services are not working yet.")]
        public string MailFrom { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue("Password")]
        [Category("- Mail Settings")]
        [DisplayName("Email Sender - Password")]
        [Description("Here you should enter the password for the Gmail Account to send with.")]
        public string MailPwd { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue("receive@yourmail.com")]
        [Category("- Mail Settings")]
        [DisplayName("Email Receiver")]
        [Description("This can be any Email Adress you like to receive the mail to.")]
        public string MailTo { get; set; }



    }
}